## START: Set by rpmautospec
## (rpmautospec version 0.8.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 11;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond tests 1

Name:           python-loguru
Version:        0.7.3
Release:        %autorelease
Summary:        Python logging made (stupidly) simple

License:        MIT
URL:            https://github.com/Delgan/loguru
# The GitHub archive contains CHANGELOG.rst, which the PyPI sdist lacks.
Source:         %{url}/archive/%{version}/loguru-%{version}.tar.gz

# Fix deprecation warning raised by tests with Python 3.14
# https://github.com/Delgan/loguru/pull/1298
# Cherry-picked to 0.7.3
Patch:          0001-Fix-deprecation-warning-raised-by-tests-with-Python-.patch
# Fix failing "exception_modern" unit test with Python 3.14 (#1331)
# https://github.com/Delgan/loguru/commit/84023e2bd8339de95250470f422f096edcb8f7b7
Patch:          %{url}/commit/84023e2bd8339de95250470f422f096edcb8f7b7.patch

BuildArch:      noarch

BuildSystem:            pyproject
BuildOption(install):   -l loguru

# The dev extra pins exact versions and includes unwanted coverage tools etc.
# (https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_linters), 
# and developer tools, so we enumerate test dependencies manually:
BuildRequires:  %{py3_dist colorama}
BuildRequires:  %{py3_dist freezegun}
BuildRequires:  %{py3_dist pytest}

# Normally we should not depend on typecheckers or linters, but the test that
# uses mypy is simply confirming that the stub file is valid and usable. That
# seems OK. Alternatively, we could pass --ignore=tests/test_type_hinting.py to
# %%pytest.
BuildRequires:  %{py3_dist mypy}

%global common_description %{expand:
Loguru is a library which aims to bring enjoyable logging in Python.}

%description %{common_description}


%package -n     python3-loguru
Summary:        %{summary}

%description -n python3-loguru %{common_description}


%prep
%autosetup -n loguru-%{version} -p1


%check -a
%if %{with tests}
# Make sure we don’t run the detailed typing tests; see
# https://docs.fedoraproject.org/en-US/packaging-guidelines/Python/#_linters
ignore="${ignore-} --ignore=tests/typesafety/test_logger.yml"

%pytest ${ignore-} -k "${k-}" -rs
%endif


%files -n python3-loguru -f %{pyproject_files}
%doc CHANGELOG.rst
%doc README.md


%changelog
## START: Generated by rpmautospec
* Sun Jul 06 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.3-11
- Backport another Python 3.14 fix; all tests now pass

* Wed Jun 04 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.3-10
- Skip two tests that still fail on Python 3.14
- Close RHBZ#2356181

* Tue Jun 03 2025 Python Maint <python-maint@redhat.com> - 0.7.3-9
- Rebuilt for Python 3.14

* Tue May 06 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.3-8
- Update (in this case, delete) .rpmlintrc file for current rpmlint

* Wed Mar 12 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.3-7
- Use the provisional pyproject declarative buildsystem

* Wed Mar 12 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.3-6
- F43+: Adapt to flit-core 3.11 handling license files per PEP 639

* Thu Feb 13 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.3-5
- Backport a patch for a DeprecationWarning in Python 3.14
- As a side effect, we no longer need to patch the tests to work without
  pytest-mypy-plugins.

* Thu Feb 13 2025 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.3-4
- Report and ignore a DeprecationWarning in Python 3.14
- Fixes RHBZ#2345523; see https://github.com/Delgan/loguru/issues/1296

* Sat Jan 18 2025 Fedora Release Engineering <releng@fedoraproject.org> - 0.7.3-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_42_Mass_Rebuild

* Fri Dec 06 2024 Packit <hello@packit.dev> - 0.7.3-1
- Update to 0.7.3 upstream release
- Resolves: rhbz#2330770

* Mon Nov 11 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.2-3
- Patch for Python 3.14; fixes RHBZ#2325199

* Sat Aug 31 2024 Benjamin A. Beasley <code@musicinmybrain.net> - 0.7.2-1
- Initial package (close RHBZ#2307475)
## END: Generated by rpmautospec
